@echo off

rem file      : etc/environments/default-mingw.bat
rem copyright : Copyright (c) 2014-2019 Code Synthesis Ltd
rem license   : TBC; see accompanying LICENSE file

rem
rem Environment setup script for C/C++ compilation with MinGW GCC.
rem
rem Note that we assume the compiler's default target is x86_64-w64-mingw32
rem and, if requested, i686-w64-mingw32 can be selected with -m32.
rem

rem %1  - target
rem %2  - bbot executable
rem %3+ - bbot options

setlocal EnableExtensions EnableDelayedExpansion

set "MINGW=C:\build2\bin"

set "PATH=$MINGW;%PATH%"

rem Based on target determine what we are building.
rem
if "_%1_" == "_x86_64-w64-mingw32_" (
  set "mode="
) else (
  if "_%1_" == "_i686-w64-mingw32_" (
    set "mode=config.cc.coptions+=-m32"
  ) else (
    echo error: unknown target %1
    goto error
  )
)

%2 %3 %4 %5 %6 %7 %8 %9 cc config.c=gcc config.cxx=g++ %mode%
if errorlevel 1 goto error

goto end

:error
@echo off
endlocal
exit /b 1

:end
endlocal
